#ifndef __FIREGL_AGP_MODULE_H__
#define __FIREGL_AGP_MODULE_H__

// since the AGP sub-module can be called at any time
// we must not apply those special kernel qualifiers
#undef __initdata
#define __initdata  /* empty */
#undef __init
#define __init      /* empty */
#undef __exit
#define __exit      /* empty */

#if 1
extern int fgl_agp_ali_init(void);
extern void fgl_agp_ali_cleanup(void);
#ifndef CONFIG_GART_IOMMU
extern int fgl_agp_amd64_init(void);
extern void fgl_agp_amd64_cleanup(void);
#endif
extern int fgl_agp_amdk7_init(void);
extern void fgl_agp_amdk7_cleanup(void);
extern int fgl_agp_ati_init(void);
extern void fgl_agp_ati_cleanup(void);
extern int fgl_agp_efficeon_init(void);
extern void fgl_agp_efficeon_cleanup(void);
extern int fgl_agp_intel_init(void);
extern void fgl_agp_intel_cleanup(void);
extern int fgl_agp_intelmch_init(void);
extern void fgl_agp_intelmch_cleanup(void);
extern int fgl_agp_nvidia_init(void);
extern void fgl_agp_nvidia_cleanup(void);
extern int fgl_agp_sis_init(void);
extern void fgl_agp_sis_cleanup(void);
extern int fgl_agp_serverworks_init(void);
extern void fgl_agp_serverworks_cleanup(void);
extern int fgl_agp_via_init(void);
extern void fgl_agp_via_cleanup(void);
#endif

extern int _X(pci_module_init)(struct pci_driver*);
extern void _X(pci_unregister_driver)(struct pci_driver*);

#undef MODULE_DEVICE_TABLE
#undef pci_module_init
#undef pci_unregister_driver
#define MODULE_DEVICE_TABLE(pci, pci_table)
#define pci_module_init _X(pci_module_init)
#define pci_unregister_driver _X(pci_unregister_driver)

#undef AGPGART_VERSION_MINOR
#undef EXPORT_SYMBOL
#define EXPORT_SYMBOL(x)
#undef EXPORT_SYMBOL_GPL
#define EXPORT_SYMBOL_GPL(x)
#undef MODULE_AUTHOR
#define MODULE_AUTHOR(x)
#undef MODULE_ALIAS_MISCDEV
#define MODULE_ALIAS_MISCDEV(x)
#undef MODULE_DESCRIPTION
#define MODULE_DESCRIPTION(x)
#endif
